ButtonGrid/Models/ButtonModel.cs
namespace ButtonGrid.Models
{
    public class ButtonModel
    {
        public int Id { get; set; }
        public int ButtonState { get; set; }

        public ButtonModel() { }

        public ButtonModel(int id, int buttonState)
        {
            Id = id;
            ButtonState = buttonState;
        }
    }
}

ButtonGrid/Models/ErrorViewModel.cs
namespace ButtonGrid.Models
{
    public class ErrorViewModel
    {
        public string? RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

ButtonGrid/Controllers/ButtonController.cs
using ButtonGrid.Models;
using Microsoft.AspNetCore.Mvc;

namespace ButtonGrid.Controllers
{
    public class ButtonController : Controller
    {
        static List<ButtonModel> buttons = new();
        private Random random = new();
        const int GRID_SIZE = 25;

        public IActionResult Index()
        {
            buttons = new List<ButtonModel>();

            for (int i = 0; i < GRID_SIZE; i++)
            {
                buttons.Add(new ButtonModel(i, random.Next(4)));
            }

            return View("Index", buttons);
        }

        [HttpPost]
        public IActionResult HandleButtonClick(int buttonId)
        {
            // Handle the button click based on the buttonId
            // Add your logic here

            return RedirectToAction("Index");
        }
    }
}

ButtonGrid/Controllers/HomeController.cs
using ButtonGrid.Models;
using Microsoft.AspNetCore.Mvc;
using System.Diagnostics;

namespace ButtonGrid.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;

        public HomeController(ILogger<HomeController> logger)
        {
            _logger = logger;
        }

        public IActionResult Index()
        {
            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

ButtonGrid/Views/Button/Index.cshtml
@model IEnumerable<ButtonGrid.Models.ButtonModel>

<div class="button-container">
	@foreach (var item in Model)
	{
		<div class="button-wrapper">
			<form method="post" asp-action="HandleButtonClick">
				<input type="hidden" name="buttonId" value="@item.Id" />
				<button type="submit" class="button-submit">
					@if (item.ButtonState == 0)
					{
						<img class="button-img" src="~/img/blue.jpg" />
						<div class="button-label">Blue</div>
					}
					@if (item.ButtonState == 1)
					{
						<img class="button-img" src="~/img/green.jpg" />
						<div class="button-label">Green</div>
					}
					@if (item.ButtonState == 2)
					{
						<img class="button-img" src="~/img/red.jpg" />
						<div class="button-label">Red</div>
					}
					@if (item.ButtonState == 3)
					{
						<img class="button-img" src="~/img/yellow.jpg" />
						<div class="button-label">Yellow</div>
					}
				</button>
			</form>
		</div>
	}
</div>

ButtonGrid/Views/Home/Index.cshtml
@{
	ViewData["Title"] = "Home Page";
}

<div class="text-center">
	<h1 class="display-4">Welcome</h1>
	<p>Learn about <a href="https://docs.microsoft.com/aspnet/core">building Web apps with ASP.NET Core</a>.</p>
    
	<a class="btn btn-primary" asp-controller="Button" asp-action="Index">Go to Button Page</a>
</div>

ButtonGrid/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - ButtonGrid</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true" />
    <link rel="stylesheet" href="~/ButtonGrid.styles.css" asp-append-version="true" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container-fluid">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">ButtonGrid</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2023 - ButtonGrid - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>